/*
 * Copyright (c) 1992 Michael A. Cooper.
 * This software may be freely distributed provided it is not sold for 
 * profit and the author is credited appropriately.
 */

/*
 * $Header: /tmp_mnt/auto5IF4Xwr/common/usc/bin/sysinfo/RCS/info-aix.h,v 1.4 1992/11/30 01:19:04 mcooper Exp mcooper $
 *
 */

/*
 * AIX specific header file
 */

#include <sys/cfgdb.h>
#include <sys/cfgodm.h>

/*
 * Directories where the catalog files of devices reside.
 * The file is usually called "devices.cat" and can be
 * found in "/usr/lib/methods" as well as "/usr/lib/nls/msg/%L"
 * The former usually contains a later version than the latter.
 */
#define ENV_NLSPATH \
"NLSPATH=/usr/lib/methods/%N:/usr/lib/nls/msg/%L/%N:/usr/lib/nls/msg/prime/%N"

/*
 * Name of default national language ($LANG)
 */
#define DEFAULT_LANG	"En_US"

/*
 * Node Name
 */
#define NN_SYS0		"sys0"

/*
 * Attribute strings
 */
#define AT_SIZE		"size"
#define AT_MODELCODE	"modelcode"
#define AT_REALMEM	"realmem"

/*
 * Vital Product Data Information
 */
struct _vpdinfo {
    char		       *code;
    char		       *title;
    char		       *value;
};
typedef struct _vpdinfo vpdinfo_t;
