/*
 * Copyright (c) 1992 Michael A. Cooper.
 * This software may be freely distributed provided it is not sold for 
 * profit and the author is credited appropriately.
 */

#ifndef lint
static char *RCSid = "$Header: /src/common/usc/bin/sysinfo/RCS/info-mach.c,v 1.4 1992/04/26 23:32:06 mcooper Exp $";
#endif

/*
 * $Log: info-mach.c,v $
 * Revision 1.4  1992/04/26  23:32:06  mcooper
 * Add Copyright notice
 *
 * Revision 1.3  1992/03/22  01:05:09  mcooper
 * Major cleanup and re-org.
 *
 * Revision 1.3  1992/03/22  01:05:09  mcooper
 * Major cleanup and re-org.
 *
 * Revision 1.2  1992/03/22  00:20:10  mcooper
 * Major cleanup and re-org.
 *
 * Revision 1.1  1992/03/01  23:28:16  mcooper
 * Initial revision
 *
 */

/*
 * Mach specific information
 */

#include <stdio.h>
#include "system.h"
#include "defs.h"

/*
 * Table of system models
 */
NAMETAB ModelTabMach[] = {
#if	defined(vax)
#ifdef CPU_SUBTYPE_VAX780
    {  CPU_SUBTYPE_VAX780,		"VAX-11/780" },
#endif
#ifdef CPU_SUBTYPE_VAX785
    {  CPU_SUBTYPE_VAX785,		"VAX-11/785" },
#endif
#ifdef CPU_SUBTYPE_VAX750
    {  CPU_SUBTYPE_VAX750,		"VAX-11/750" },
#endif
#ifdef CPU_SUBTYPE_VAX730
    {  CPU_SUBTYPE_VAX730,		"VAX-11/730" },
#endif
#ifdef CPU_SUBTYPE_UVAXI
    {  CPU_SUBTYPE_UVAXI,		"MicroVAX-I" },
#endif
#ifdef CPU_SUBTYPE_UVAXII
    {  CPU_SUBTYPE_UVAXII,		"MicroVAX-II" },
#endif
#ifdef CPU_SUBTYPE_VAX8200
    {  CPU_SUBTYPE_VAX8200,		"VAX-8200" },
#endif
#ifdef CPU_SUBTYPE_VAX8500
    {  CPU_SUBTYPE_VAX8500,		"VAX-8500" },
#endif
#ifdef CPU_SUBTYPE_VAX8600
    {  CPU_SUBTYPE_VAX8600,		"VAX-8600" },
#endif
#ifdef CPU_SUBTYPE_VAX8650
    {  CPU_SUBTYPE_VAX8650,		"VAX-8650" },
#endif
#ifdef CPU_SUBTYPE_VAX8800
    {  CPU_SUBTYPE_VAX8800,		"VAX-8800" },
#endif
#ifdef CPU_SUBTYPE_UVAXIII
    {  CPU_SUBTYPE_UVAXIII,		"MicroVAX-III" },
#endif
#endif	/* vax */
#if	defined(ibm)
#ifdef CPU_SUBTYPE_RT_PC
    {  CPU_SUBTYPE_RT_PC,		"RT/PC" },
#endif
#ifdef CPU_SUBTYPE_RT_APC
    {  CPU_SUBTYPE_RT_APC,		"RT/APC" },
#endif
#ifdef CPU_SUBTYPE_RT_135
    {  CPU_SUBTYPE_RT_135,		"RT/135" },
#endif
#endif	/* ibm */
#if	defined(mips)
#ifdef CPU_SUBTYPE_MIPS_R2300
    {  CPU_SUBTYPE_MIPS_R2300,		"MIPS R2300" },
#endif
#ifdef CPU_SUBTYPE_MIPS_R2600
    {  CPU_SUBTYPE_MIPS_R2600,		"MIPS R2600" },
#endif
#ifdef CPU_SUBTYPE_MIPS_R2800
    {  CPU_SUBTYPE_MIPS_R2800,		"MIPS R2800" },
#endif
#ifdef CPU_SUBTYPE_MIPS_R2000a
    {  CPU_SUBTYPE_MIPS_R2000a,		"MIPS R2000a" },
#endif
#endif	/* mips */
#if	defined(mc68k)
#ifdef CPU_SUBTYPE_MC68030
    {  CPU_SUBTYPE_MC68030,		"MC68030" },
#endif
#ifdef CPU_SUBTYPE_MC68040
    {  CPU_SUBTYPE_MC68040,		"MC68040" },
#endif
#endif	/* mc68k */
#if	defined(hp)
#ifdef CPU_SUBTYPE_HPPA_825
    {  CPU_SUBTYPE_HPPA_825,		"9000/825" },
#endif
#ifdef CPU_SUBTYPE_HPPA_835
    {  CPU_SUBTYPE_HPPA_835,		"9000/835" },
#endif
#ifdef CPU_SUBTYPE_HPPA_840
    {  CPU_SUBTYPE_HPPA_840,		"9000/840" },
#endif
#ifdef CPU_SUBTYPE_HPPA_850
    {  CPU_SUBTYPE_HPPA_850,		"9000/850" },
#endif
#ifdef CPU_SUBTYPE_HPPA_855
    {  CPU_SUBTYPE_HPPA_855,		"9000/855" },
#endif
#endif	/* hp */
#if	defined(sun)
#ifdef CPU_SUBTYPE_SUN4_260
    {  CPU_SUBTYPE_SUN4_260,		"4/200" },
#endif
#ifdef CPU_SUBTYPE_SUN4_110
    {  CPU_SUBTYPE_SUN4_110,		"4/110" },
#endif
#endif	/* sun */
    {  0 },
};

/*
 * Table of CPU Types
 */
NAMETAB CpuTypeTab[] = {
#ifdef CPU_TYPE_VAX
    {  CPU_TYPE_VAX,			"VAX" },
#endif
#ifdef CPU_TYPE_ROMP
    {  CPU_TYPE_ROMP,			"ROMP" },
#endif
#ifdef CPU_TYPE_NS32032
    {  CPU_TYPE_NS32032,		"NS32032" },
#endif
#ifdef CPU_TYPE_NS32332
    {  CPU_TYPE_NS32332,		"NS32332" },
#endif
#ifdef CPU_TYPE_MC680x0
    {  CPU_TYPE_MC680x0,		"MC680X0" },
#endif
#ifdef CPU_TYPE_I386
    {  CPU_TYPE_I386,			"i386" },
#endif
#ifdef CPU_TYPE_NS32532
    {  CPU_TYPE_NS32532,		"NS32532" },
#endif
#ifdef CPU_TYPE_HPPA
    {  CPU_TYPE_HPPA,			"HPPA" },
#endif
#ifdef CPU_TYPE_ARM
    {  CPU_TYPE_ARM,			"ARM" },
#endif
#ifdef CPU_TYPE_MC88000
    {  CPU_TYPE_MC88000,		"MC88000" },
#endif
#ifdef CPU_TYPE_SPARC
    {  CPU_TYPE_SPARC,			"SPARC" },
#endif
    {  0 },
};
