/*
 * Copyright (c) 1992 Michael A. Cooper.
 * This software may be freely distributed provided it is not sold for 
 * profit and the author is credited appropriately.
 */

#ifndef lint
static char *RCSid = "$Header: /src/common/usc/bin/sysinfo/RCS/info-next.c,v 1.8 1992/12/12 23:12:02 mcooper Exp $";
#endif

/*
 * $Log: info-next.c,v $
 * Revision 1.8  1992/12/12  23:12:02  mcooper
 * Use new format DEVDATATAB.
 * Update list of devices.
 *
 * Revision 1.7  1992/11/24  04:05:57  mcooper
 * New/cleaner KVM/nlist interface.
 *
 * Revision 1.6  1992/07/07  23:28:38  mcooper
 * Put wrapper macro around nlist stuff to fix NeXT/Mach declaration
 * problem.  Now works with NeXT 2.* cc compiler.
 *
 * Revision 1.5  1992/04/26  23:32:06  mcooper
 * Add Copyright notice
 *
 * Revision 1.4  1992/04/17  01:10:11  mcooper
 * Moved DEVICE *() function declares to defs.h.
 *
 * Revision 1.3  1992/03/28  21:59:28  mcooper
 * Implemented disk and netif device probing.
 *
 * Revision 1.2  1992/03/22  02:02:26  mcooper
 * Add NeXTBusNL nlist.
 *
 * Revision 1.1  1992/03/22  01:04:34  mcooper
 * Initial revision
 *
 */


/*
 * NeXT related information
 */

#include <stdio.h>
#include "system.h"
#include "defs.h"

/*
 * Kernel variable containing model number.
 */
char				MachineTypeSYM[] = "_machine_type";

/*
 * Kernel symbol for the device table
 */
char				NeXTBusSYM[] = "_bus_dinit";

/*
 * Models of NeXT machines as defined in <next/scr.h>
 */
#include <next/scr.h>
NAMETAB ModelTab[] = {
#ifdef NeXT_CUBE
    {  NeXT_CUBE, 	"NeXTCube (MC68030)" },
#endif
#ifdef NeXT_WARP9
    {  NeXT_WARP9,	"NeXTStation" },
#endif
#ifdef NeXT_X15
    {  NeXT_X15,	"NeXTCube (MC68040)" },
#endif
#ifdef NeXT_WARP9C
    {  NeXT_WARP9C,	"NeXTWarp9C" },
#endif
    {  0 },
};

/*
 * Device Data Table
 */
DEVDATATAB DevDataTab[] = {
    { "sc",	NULL,	"SCSI Controller", 		NULL },
    { "odc",	NULL,	"Optical Disk Controller", 	NULL },
    { "fdc",	NULL,	"Floppy Disk Controller", 	NULL },
    { "sd",	NULL,	NULL,				ProbeDiskDrive },
    { "od",	NULL,	NULL,				ProbeDiskDrive },
    { "fd",	NULL,	NULL,				ProbeDiskDrive },
    { "en",	"EtherNet Interface","10Mb/sec Ethernet",ProbeNetif },
    { "dsp",	NULL,	"Digital Signal Processor", 	ProbeGeneric },
    { "np",	NULL,	"NeXT Printer",		 	ProbeGeneric },
    /*
     * These devices are usually indicated as present, but may only
     * exist as device drivers so we ignore them.
     */
    { "sg",	NULL,	NULL,				NULL },
    { "sound",	NULL,	NULL,				NULL },
    {  0 },
};
