/* config.h:
 *
 * configuration file for 'msend'
 *
 * (c) Copyright 1991 Jim Frost.  All Rights Reserved.  Please see
 * the accompanying file "Copyright" for more information.
 */

#define ON 1
#define OFF 0

/* system dependencies and options
 */

#define PORTNUM      948   /* port number that we use.  should be under
                               1024 for installed versions to make sure
                               we're getting real data.  note that an
                               /etc/services entry overrides this */

#define DBROADCAST    /* allow broadcasting at daemon host */
#define CBROADCAST    /* allow broadcasting from user interface */
#define ROUTE         /* allow message routing at daemon host */
#define SECURE_PORT   /* connect from a secure port to allow authentication */
#define GNUREADLINE   /* use GNU readline for the user interface. */
#define EDIT ON       /* should gnureadline editing be ON/OFF by default */
/* #define ALONE      /* not running under inetd - build standalone daemon */

/* this is the name of the log file msend will use.  /usr/adm/msend.log is
 * usually good.
 */
#define LOGFILE     "/usr/adm/msend.log"

/* if you would rather have the spool files in individual users' directories,
 * comment this line out. */
#define SPOOLDIR    "/usr/spool/msend"

/* a few common systems' definitions
 */
#ifdef sun
/* nothing special about a Sun */
#endif

#ifdef _AIX
#define NEEDS_FLOCK
#define SYSV_WAIT_STATUS
#endif

#if defined(sgi) && defined(mips)
#define SYSVUTMP
#endif

/* system-dependent definitions
 */
/* #define NEEDS_FLOCK /* OS lacks flock() */
/* #define SYSVUTMP   /* system uses SYSV style utmp file */
/* #define NOHERROR  /* systems libraries do not contain h_errno. */
/* #define SYSV_WAIT_STATUS /* wait status is int not union */
/* #define SYSV_SETUID /* if your system uses SYSV setuid semantics*/

#ifdef SYSV_SETUID
#define seteuid(uid) setuid(uid) /* If OS lacks seteuid(2) and setruid(2) */
#define setruid(uid) 0 /* and has SYSV setuid(2) semantics */
#endif

/* BSD systems define wait status as a union, while SYSV as an int.
 */
#ifdef SYSV_WAIT_STATUS
#define WAIT_STATUS int        /* SYSV-style wait status */
#else
#define WAIT_STATUS union wait /* BSD-style wait status */
#endif

