.TH MSEND 1 "11 Dec member 1991"
.SH NAME
msend \- send an immediate message to another user
.SH SYNOPSIS
.B msend
user[@host] [message]
.br
.B msend .
[message]
.br
.B msend
\-clean
.br
.B msend
\-Tttyname [@host] [message]
.br
.B msend
\-B @host [message]
.br
.B msend
\-huh [# of messages]
.SH DESCRIPTION
\fIMsend\fR is used to send immediate messages to other users.  It
operates both locally and between hosts.  If configured to do so, it
has the ability to broadcast to all users on a machine and/or allow
manual routing of messages to other hosts.
.PP
A dot (.) in place of a username indicates an attempt to send to the
same user as the last invocation.  The username of the last send is
stored in ~/.lastmsend.
.PP

If a message is specified on the command line, an attempt is made to
send the message to the specified user, tty, or host.  If no message
is specified, \fImsend\fR goes into an interactive mode, sending each
typed line to the specified user.  Interactive mode can be exited via
end-of-file or a dot (.) alone on a line.
.SH ROUTING
In some environments, it may be necessary to route a message by hand
in order to reach a specific host.  \fIMsend\fR allows you to specify
a list of host names which will be read from right to left until an
error occurs or until the last host in the list.  Routing is allowed
anywhere @host may be used.
.PP
Since some administrators may not want users routing messages to
non-local systems, routing may be disabled at compilation time.  An
error message is returned whenever a daemon with disabled routing is
encountered.
.SH OPTIONS
The following options are available with \fImsend\fR.
.TP 8
\fB-Tttyname [@host]\fR
Specify a specific terminal (optionally on a different host) to send a
message to.
.TP
\fB-B @host\fR
Attempt to broadcast to all users on the indicated system.
Broadcasting can be disabled at the client and/or the daemon at
compilation time, allowing the system administrator to control
incoming or outgoing broadcast messages.  All broadcast messages are
logged.
.TP
\fB-clean\fR
Erase the file of old messages.
.TP
\fB-edit\fR
Toggle command line editing if using the GNU Readline interface.
.TP
\fB-huh [# of messages]\fR
Reprint the last message (or messages) that were sent to you on this
host.
.SH OPTIONS FILE
To allow a user to tailor his message environment, the send programs
look for .msendrc in the user's home directory.  The "signature" option
is the only option that affects outgoing messages; all others affect
incoming messages.  The options are:
.TP
\fBsignature "format string"\fR
This is used to allow customization of messages that you send to other
users.  The string within quotes will be appended to your name and
host when the message is sent.  If %d or %t is included in the string,
the date or your tty (respectively) will be inserted in its place.
.TP
\fBallttys\fR
Attempt to write to all ttys owned by the intended recipient on the
local host.
.TP
\fBforward-to-user user[@host]\fR
Instead of writing to this user, forward the message to another user.
This is especially useful when you have multiple accounts.
.TP
\fBwrite-and-forward user[@host]\fR
This is similar to forward-to-user, but will also attempt to write to
the user locally.
.TP
\fBwrite-on-tty ttyname\fR
Attempt to write to a particular local tty.  This is
useful with workstations to force writes to a particular window.
.TP
\fBforward-to-tty ttyname @host\fP
Attempt to write to a given tty on the indicated host.
.TP
\fBhistory number\fP
Number of lines of history to keep if using the GNU Readline
interface.  The default is unlimited.
.TP
\fBediting_mode "emacs"|"vi"\fP
Use emacs- or vi-style command line editing if using the GNU Readline
interface.  The default is emacs-style.
.TP
\fBedit "on"|"off"\fP
Enable or disable command line editing if using the GNU Readline
interface.  The default is site dependant, but tends to be off as GNU
Readline interface has problems on some terminals.
.SH AUTHORS
.nf
Jim Frost
\fBjimf@centerline.com\fP
.LP
Joe Ilacqua
\fBspike@world.std.com\fP
.fi
.SH FILES
.PP
~/.lastmsend
.br
~/.msendrc
.br
/usr/spool/msend/*
.br
/usr/adm/msend.log
.SH BUGS
If you find any, let us know.

